/*
 *
 */

#include <stdio.h>
#include <signal.h>
#include <unistd.h>

volatile sig_atomic_t keep_going = 1;

static void
catcher(int signum)
{
    keep_going = 0;
}

static double
getload()
{
    FILE *f;
    double load;
    
    f = popen("uptime", "r");
    if (! f) {
	return -1;
    }

    /*  19:06:48 up  2:53,  1 user,  load average: 0.15, 0.06, 0.03 */
    
    if (fscanf(f, "%*s %*s %*s %*s %*s %*s %*s %lf", &load) != 1) {
	pclose(f);
	return -1;
    }

    pclose(f);

    return load;
}

int
main(int argc, char *argv[])
{
    double l;
    int i;
    
    signal(SIGINT, catcher);
    
    while (keep_going) {
	l = getload();
	if (l >= 0) {
	    for (i = 0; i < l * 40; i++) {
		printf("*");
	    }
	}
	printf("\n");
	sleep(3);
    }
    
    return 0;
}
